Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.meta.strats
Class PrimitiveFieldStrategy

    java.lang.Object
      org.apache.openjpa.jdbc.meta.strats.AbstractStrategy
          org.apache.openjpa.jdbc.meta.strats.AbstractFieldStrategy
              org.apache.openjpa.jdbc.meta.strats.PrimitiveFieldStrategy

All Implemented Interfaces:
  Serializable, Embeddable, FieldStrategy, Joinable, Strategy

    public class PrimitiveFieldStrategy

extends AbstractFieldStrategy
implements Joinable, Embeddable

Direct mapping from a primitive value to a column.

Since:
  0.4.0
Author:
  Abe White
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.openjpa.jdbc.meta.strats.AbstractFieldStrategy
`field`

Fields inherited from interface org.apache.openjpa.jdbc.meta.Embeddable
`UNSUPPORTED`

Constructor Summary
`PrimitiveFieldStrategy()`

Method Summary
`void` | `appendIsNotNull(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is not null.
`void` | `appendIsNull(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is null.
`void` | `delete(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates.
`ColumnIO` | `getColumnIO()` Return column I/O information for this mapping.
`Column[]` | `getColumns()` The columns managed by this joinable.
`int` | `getFieldIndex()` Return the field index of this joinable, or -1 if not a field.
`Object` | `getJoinValue(Object fieldVal, Column col, JDBCStore store)` Return the join value of the given column.
`Object` | `getJoinValue(OpenJPAStateManager sm, Column col, JDBCStore store)` Return the join value of the given column.
`Object` | `getPrimaryKeyValue(Result res, Column[] cols, ForeignKey fk, JDBCStore store, Joins joins)` Return the value for this joinable from the given result, using the given columns.
`Object[]` | `getResultArguments()` Return the arguments needed to extract datastore values via `Result.getObject(java.lang.Object, int, java.lang.Object)` for each column.
`void` | `initialize()` Perform caching and other initialization operations.
`void` | `insert(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.
`boolean` | `isVersionable()` Return true if this field can be used as part of a state image for optimistic locking.
`Joins` | `join(Joins joins, boolean forceOuter)` Join this value to the class table.
`void` | `load(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, Result res)` Load virtual row data; the given result is not guaranteed to contain data for this field, so the field mapping should make sure the result contains its needed column data before loading.
`void` | `loadEmbedded(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, Object val)` Load this strategy's field by transforming the given datastore value.
`Object` | `loadProjection(JDBCStore store, JDBCFetchConfiguration fetch, Result res, Joins joins)` Load this field value using the given result.
`void` | `map(boolean adapt)` Map the owning mapping using this strategy.
`int` | `select(Select sel, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, int eagerMode)` Select the virtual row columns of this mapping.
`void` | `setAutoAssignedValue(OpenJPAStateManager sm, JDBCStore store, Column col, Object autoInc)` Use the given auto-assigned value to set this join value's field on the given instance.
`int` | `supportsSelect(Select sel, int type, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch)` Return whether this mapping can perform the given select type.
`Object` | `toEmbeddedDataStoreValue(Object val, JDBCStore store)` Convert the given Java value to its datastore equivalent.
`Object` | `toEmbeddedObjectValue(Object val)` Convert the given datastore value to its Java equivalent.
`void` | `update(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.
`void` | `where(OpenJPAStateManager sm, JDBCStore store, RowManager rm, Object prevValue)` Add a WHERE condition to the row for this field such that the field's current DB value must equal the given previous value.

Methods inherited from class org.apache.openjpa.jdbc.meta.strats.AbstractFieldStrategy
`appendIndex, appendIsEmpty, appendIsNotEmpty, appendSize, appendType, assertNotMappedBy, isEagerSelectToMany, joinKey, joinKeyRelation, joinRelation, load, loadEagerJoin, loadEagerParallel, loadKeyProjection, selectEagerJoin, selectEagerParallel, setFieldMapping, toDataStoreValue, toKeyDataStoreValue`

Methods inherited from class org.apache.openjpa.jdbc.meta.strats.AbstractStrategy
`customDelete, customInsert, customUpdate, getAlias, isCustomDelete, isCustomInsert, isCustomUpdate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.openjpa.jdbc.meta.Strategy
`customDelete, customInsert, customUpdate, getAlias, isCustomDelete, isCustomInsert, isCustomUpdate`

Constructor Detail

### PrimitiveFieldStrategy

    public PrimitiveFieldStrategy()

Method Detail

### map

    public void map(boolean adapt)

  Description copied from interface: `Strategy`
  Map the owning mapping using this strategy.

  Specified by:
    `map` in interface `Strategy`
  Overrides:
    `map` in class `AbstractStrategy`
  Parameters:
    `adapt` - if true, use the owning mapping's raw mapping info to set its ORM data; if false, ORM data will already be set

### initialize

    public void initialize()

  Description copied from interface: `Strategy`
  Perform caching and other initialization operations. This method is called after `Strategy.map(boolean)`, and after all related components have been mapped as well.

  Specified by:
    `initialize` in interface `Strategy`
  Overrides:
    `initialize` in class `AbstractStrategy`

### insert

    public void insert(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows. For class mappings, this method will be called only after the corresponding method has been called for all fields of this mapping.

  Specified by:
    `insert` in interface `Strategy`
  Overrides:
    `insert` in class `AbstractStrategy`
  Throws:
    `SQLException`

### update

    public void update(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows.

  Specified by:
    `update` in interface `Strategy`
  Overrides:
    `update` in class `AbstractStrategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### delete

    public void delete(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates. This allows foreign key analysis.

  Specified by:
    `delete` in interface `Strategy`
  Overrides:
    `delete` in class `AbstractStrategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### supportsSelect

    public int supportsSelect(Select sel,
                              int type,
                              OpenJPAStateManager sm,
                              JDBCStore store,
                              JDBCFetchConfiguration fetch)

  Description copied from interface: `FieldStrategy`
  Return whether this mapping can perform the given select type. Return 0 if the given type is not supported. If the given type is an eager parallel type, return the number of UNIONed selects necessary to fetch the data. Otherwise, return any positive number if the type is supported. The given state manager may be null if selecting multiple instances.

  Specified by:
    `supportsSelect` in interface `FieldStrategy`
  Overrides:
    `supportsSelect` in class `AbstractFieldStrategy`
  See Also:
    `Select`

### select

    public int select(Select sel,
                      OpenJPAStateManager sm,
                      JDBCStore store,
                      JDBCFetchConfiguration fetch,
                      int eagerMode)

  Description copied from interface: `FieldStrategy`
  Select the virtual row columns of this mapping.

  Specified by:
    `select` in interface `FieldStrategy`
  Overrides:
    `select` in class `AbstractFieldStrategy`
  Parameters:
    `sel` - the select to add to
    `sm` - the instance being loaded, or null if not initialized yet or selecting for multiple instances
    `store` - the current store manager
    `fetch` - fetch configuration
    `eagerMode` - the eager fetch mode to use; this may be more restrictive than the mode of the fetch configuration
  Returns:
    > 0 if this mapping requires the selected data (if any), 0 if it selected data but does not require it, or < 0 if no data was selected

### load

    public void load(OpenJPAStateManager sm,
                     JDBCStore store,
                     JDBCFetchConfiguration fetch,
                     Result res)
              throws SQLException

  Description copied from interface: `FieldStrategy`
  Load virtual row data; the given result is not guaranteed to contain data for this field, so the field mapping should make sure the result contains its needed column data before loading.

  Specified by:
    `load` in interface `FieldStrategy`
  Overrides:
    `load` in class `AbstractFieldStrategy`
  Throws:
    `SQLException`

### appendIsNull

    public void appendIsNull(SQLBuffer sql,
                             Select sel,
                             Joins joins)

  Description copied from interface: `FieldStrategy`
  Append a where clause to the given statement checking if this value is null.

  Specified by:
    `appendIsNull` in interface `FieldStrategy`
  Overrides:
    `appendIsNull` in class `AbstractFieldStrategy`

### appendIsNotNull

    public void appendIsNotNull(SQLBuffer sql,
                                Select sel,
                                Joins joins)

  Description copied from interface: `FieldStrategy`
  Append a where clause to the given statement checking if this value is not null.

  Specified by:
    `appendIsNotNull` in interface `FieldStrategy`
  Overrides:
    `appendIsNotNull` in class `AbstractFieldStrategy`

### join

    public Joins join(Joins joins,
                      boolean forceOuter)

  Description copied from interface: `FieldStrategy`
  Join this value to the class table. Does nothing by default.

  Specified by:
    `join` in interface `FieldStrategy`
  Overrides:
    `join` in class `AbstractFieldStrategy`

### loadProjection

    public Object loadProjection(JDBCStore store,
                                 JDBCFetchConfiguration fetch,
                                 Result res,
                                 Joins joins)
                          throws SQLException

  Description copied from interface: `FieldStrategy`
  Load this field value using the given result. The result will contain the columns from `ValueMapping.getColumns()`.

  Specified by:
    `loadProjection` in interface `FieldStrategy`
  Overrides:
    `loadProjection` in class `AbstractFieldStrategy`
  Throws:
    `SQLException`

### isVersionable

    public boolean isVersionable()

  Description copied from interface: `FieldStrategy`
  Return true if this field can be used as part of a state image for optimistic locking.

  Specified by:
    `isVersionable` in interface `FieldStrategy`
  Overrides:
    `isVersionable` in class `AbstractFieldStrategy`

### where

    public void where(OpenJPAStateManager sm,
                      JDBCStore store,
                      RowManager rm,
                      Object prevValue)
               throws SQLException

  Description copied from interface: `FieldStrategy`
  Add a WHERE condition to the row for this field such that the field's current DB value must equal the given previous value. Only versionable mappings must implement this method meaningfully.

  Specified by:
    `where` in interface `FieldStrategy`
  Overrides:
    `where` in class `AbstractFieldStrategy`
  Throws:
    `SQLException`

### getFieldIndex

    public int getFieldIndex()

  Description copied from interface: `Joinable`
  Return the field index of this joinable, or -1 if not a field.

  Specified by:
    `getFieldIndex` in interface `Joinable`

### getPrimaryKeyValue

    public Object getPrimaryKeyValue(Result res,
                                     Column[] cols,
                                     ForeignKey fk,
                                     JDBCStore store,
                                     Joins joins)
                              throws SQLException

  Description copied from interface: `Joinable`
  Return the value for this joinable from the given result, using the given columns. If the given foreign key is non-null, use the foreign key's columns by translating the given columns through `ForeignKey.getColumn(org.apache.openjpa.jdbc.schema.Column)`.

  Specified by:
    `getPrimaryKeyValue` in interface `Joinable`
  Throws:
    `SQLException`

### getColumns

    public Column[] getColumns()

  Description copied from interface: `Joinable`
  The columns managed by this joinable.

  Specified by:
    `getColumns` in interface `Embeddable`
  Specified by:
    `getColumns` in interface `Joinable`

### getJoinValue

    public Object getJoinValue(Object fieldVal,
                               Column col,
                               JDBCStore store)

  Description copied from interface: `Joinable`
  Return the join value of the given column.

  Specified by:
    `getJoinValue` in interface `Joinable`
  Parameters:
    `fieldVal` - the value of the field for this joinable
    `col` - the column of this joinable whose value to return

### getJoinValue

    public Object getJoinValue(OpenJPAStateManager sm,
                               Column col,
                               JDBCStore store)

  Description copied from interface: `Joinable`
  Return the join value of the given column.

  Specified by:
    `getJoinValue` in interface `Joinable`
  Parameters:
    `sm` - the instance from which to get the value
    `col` - the column whose value to return

### setAutoAssignedValue

    public void setAutoAssignedValue(OpenJPAStateManager sm,
                                     JDBCStore store,
                                     Column col,
                                     Object autoInc)

  Description copied from interface: `Joinable`
  Use the given auto-assigned value to set this join value's field on the given instance.

  Specified by:
    `setAutoAssignedValue` in interface `Joinable`

### getColumnIO

    public ColumnIO getColumnIO()

  Description copied from interface: `Embeddable`
  Return column I/O information for this mapping.

  Specified by:
    `getColumnIO` in interface `Embeddable`

### getResultArguments

    public Object[] getResultArguments()

  Description copied from interface: `Embeddable`
  Return the arguments needed to extract datastore values via `Result.getObject(java.lang.Object, int, java.lang.Object)` for each column.

  Specified by:
    `getResultArguments` in interface `Embeddable`

### toEmbeddedObjectValue

    public Object toEmbeddedObjectValue(Object val)

  Description copied from interface: `Embeddable`
  Convert the given datastore value to its Java equivalent. If `Embeddable.getColumns()` returns multiple columns, the given datastore value will be an object array of the corresponding length. This method must only be supported by mappings of embedded id objects. In other cases `Embeddable.loadEmbedded(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.kernel.JDBCFetchConfiguration, java.lang.Object)` will be used instead. Return `Embeddable.UNSUPPORTED` if this mapping cannot support this method.

  Specified by:
    `toEmbeddedObjectValue` in interface `Embeddable`

### toEmbeddedDataStoreValue

    public Object toEmbeddedDataStoreValue(Object val,
                                           JDBCStore store)

  Description copied from interface: `Embeddable`
  Convert the given Java value to its datastore equivalent. If this mapping occupies multiple columns, return an object array with one element per column. For relation id columns, return the state manager the column depends on.

  Specified by:
    `toEmbeddedDataStoreValue` in interface `Embeddable`

### loadEmbedded

    public void loadEmbedded(OpenJPAStateManager sm,
                             JDBCStore store,
                             JDBCFetchConfiguration fetch,
                             Object val)
                      throws SQLException

  Description copied from interface: `Embeddable`
  Load this strategy's field by transforming the given datastore value. If `Embeddable.getColumns()` returns multiple columns, the given datastore value will be an object array of the corresponding length. The value does not have to be loaded immediately; it may be stored as impl data.

  Specified by:
    `loadEmbedded` in interface `Embeddable`
  Throws:
    `SQLException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.